02ceecfd871755390d25a1ade6f773f9dd75bda2
[releng.git] / jjb / opnfv / opnfv-docker.sh
1 #!/bin/bash
2 set -o errexit
3 set -o nounset
4 set -o pipefail
5
6
7 echo "Starting opnfv-docker for $DOCKER_REPO_NAME ..."
8 echo "--------------------------------------------------------"
9 echo
10
11
12 # Remove previous running containers if exist
13 if [[ ! -z $(docker ps -a | grep $DOCKER_REPO_NAME) ]]; then
14     echo "Removing existing $DOCKER_REPO_NAME containers..."
15     #docker ps | grep $DOCKER_REPO_NAME | awk '{{print $1}}' | xargs docker stop
16     docker ps -a | grep $DOCKER_REPO_NAME | awk '{{print $1}}' | xargs docker rm -f
17     t=60
18     # Wait max 60 sec for containers to be removed
19     while [ $t -gt 0 ]; do
20         ids=$(docker ps | grep $DOCKER_REPO_NAME |awk '{{print $1}}')
21         if [[ -z $ids ]]; then
22             break
23         fi
24         sleep 1
25         let t=t-1
26     done
27 fi
28
29
30 # Remove existing images if exist
31 if [[ ! -z $(docker images | grep $DOCKER_REPO_NAME) ]]; then
32     echo "Docker images to remove:"
33     docker images | head -1 && docker images | grep $DOCKER_REPO_NAME
34     image_tags=($(docker images | grep $DOCKER_REPO_NAME | awk '{{print $2}}'))
35     for tag in "${{image_tags[@]}}"; do
36         echo "Removing docker image $DOCKER_REPO_NAME:$tag..."
37         docker rmi -f $DOCKER_REPO_NAME:$tag
38     done
39 fi
40
41 # If we just want to update the latest_stable image
42 if [[ "$UPDATE_LATEST_STABLE" == "true" ]]; then
43     echo "Pulling $DOCKER_REPO_NAME:$STABLE_TAG ..."
44     docker pull $DOCKER_REPO_NAME:$STABLE_TAG
45     if [[ $? -ne 0 ]]; then
46         echo "ERROR: The image $DOCKER_REPO_NAME with tag $STABLE_TAG does not exist."
47         exit 1
48     fi
49     docker tag -f $DOCKER_REPO_NAME:$STABLE_TAG $DOCKER_REPO_NAME:latest_stable
50     echo "Pushing $DOCKER_REPO_NAME:latest_stable ..."
51     docker push $DOCKER_REPO_NAME:latest_stable
52     exit 0
53 fi
54
55
56 # cd to directory where Dockerfile is located
57 if [[ "$DOCKER_REPO_NAME" == "opnfv/functest" ]]; then
58     cd $WORKSPACE/docker
59 elif [[ "$DOCKER_REPO_NAME" == "opnfv/yardstick" ]]; then
60     cd $WORKSPACE/ci/docker/yardstick-ci
61 elif [[ "$DOCKER_REPO_NAME" == "opnfv/storperf" ]]; then
62     cd $WORKSPACE/docker
63 elif [[ "$DOCKER_REPO_NAME" == "opnfv/qtip" ]]; then
64     cd $WORKSPACE/docker
65 else
66     echo "ERROR: DOCKER_REPO_NAME parameter not valid: $DOCKER_REPO_NAME"
67     exit 1
68 fi
69
70 # Get tag version
71 branch=$(git rev-parse --abbrev-ref HEAD)
72 echo "Current branch: $branch"
73
74 if [ $branch == "master" ]; then
75     DOCKER_TAG="master"
76 else
77     git clone https://gerrit.opnfv.org/gerrit/releng $WORKSPACE/releng
78
79     DOCKER_TAG=$($WORKSPACE/releng/utils/calculate_version.sh -t docker \
80         -n $DOCKER_REPO_NAME)
81
82     ret_val=$?
83     if [ $ret_val -ne 0 ]; then
84         echo "Error retrieving the version tag."
85         exit 1
86     fi
87 fi
88 echo "Tag version to be build and pushed: $DOCKER_TAG"
89
90
91 # Start the build
92 echo "Building docker image: $DOCKER_REPO_NAME:$DOCKER_TAG..."
93
94 docker build -t $DOCKER_REPO_NAME:$DOCKER_TAG .
95 echo "Creating tag 'latest'..."
96 docker tag $DOCKER_REPO_NAME:$DOCKER_TAG $DOCKER_REPO_NAME:latest
97
98 # list the images
99 echo "Available images are:"
100 docker images
101
102 # Push image to Dockerhub
103 if [[ "$PUSH_IMAGE" == "true" ]]; then
104     echo "Pushing $DOCKER_REPO_NAME:$DOCKER_TAG to the docker registry..."
105     echo "--------------------------------------------------------"
106     echo
107     # Push to the Dockerhub repository
108     docker push $DOCKER_REPO_NAME:$DOCKER_TAG
109
110     echo "Updating $DOCKER_REPO_NAME:latest to the docker registry..."
111     docker push $DOCKER_REPO_NAME:latest
112 fi